/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.ant.taskdefs;

import java.io.OutputStream;

import junit.framework.AssertionFailedError;
import junit.framework.Test;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter;
import org.apache.tools.ant.taskdefs.optional.junit.JUnitTest;
import org.jboss.profiler.threadcheck.StartupProfilerCheck;

/**
 * @author Clebert Suconic
 */
public class JUnitListener implements JUnitResultFormatter {

    public JUnitListener() {
        super();
    }

    /* (non-Javadoc)
     * @see org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter#startTestSuite(org.apache.tools.ant.taskdefs.optional.junit.JUnitTest)
     */
    public void startTestSuite(JUnitTest arg0) throws BuildException {
        System.out.println("startTestSuite Profiler");
        StartupProfilerCheck.startProfiler();

    }

    /* (non-Javadoc)
     * @see org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter#endTestSuite(org.apache.tools.ant.taskdefs.optional.junit.JUnitTest)
     */
    public void endTestSuite(JUnitTest arg0) throws BuildException {
        System.out.println("endTestSuite Profiler");
        StartupProfilerCheck.pauseProfiler();

    }

    /* (non-Javadoc)
     * @see org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter#setOutput(java.io.OutputStream)
     */
    public void setOutput(OutputStream arg0) {

    }

    /* (non-Javadoc)
     * @see org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter#setSystemOutput(java.lang.String)
     */
    public void setSystemOutput(String arg0) {

    }

    /* (non-Javadoc)
     * @see org.apache.tools.ant.taskdefs.optional.junit.JUnitResultFormatter#setSystemError(java.lang.String)
     */
    public void setSystemError(String arg0) {

    }

    /* (non-Javadoc)
     * @see junit.framework.TestListener#addError(junit.framework.Test, java.lang.Throwable)
     */
    public void addError(Test arg0, Throwable arg1) {

    }

    /* (non-Javadoc)
     * @see junit.framework.TestListener#addFailure(junit.framework.Test, junit.framework.AssertionFailedError)
     */
    public void addFailure(Test arg0, AssertionFailedError arg1) {

    }

    /* (non-Javadoc)
     * @see junit.framework.TestListener#endTest(junit.framework.Test)
     */
    public void endTest(Test arg0) {
        System.out.println("endTest Profiler");

    }

    /* (non-Javadoc)
     * @see junit.framework.TestListener#startTest(junit.framework.Test)
     */
    public void startTest(Test arg0) {
        System.out.println("startTest Profiler");

    }

}
