/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.profiler.ant;

import java.util.Comparator;

/**
 * @author Clebert Suconic
 */
public class ExecutionInfoSummaryComparator implements Comparator {

    public static final int NAME=0;
    public static final int CPU=1;
    public static final int BYTES=2;
    public static final int RELEASED_BYTES=3;
    public static final int NUMBER_OF_CALLINGS=4;
    
    int whatToCompare;
    public ExecutionInfoSummaryComparator(int whatToCompare) {
        super();
        this.whatToCompare=whatToCompare;
    }

    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public int compare(Object o1, Object o2) {
        int compret=0;
        long compare=0;
        switch (whatToCompare) {
           case CPU:
               compare = ((ExecutionInfoSummary)o2).cpuTime - ((ExecutionInfoSummary)o1).cpuTime;
               break;
           case BYTES:
               compare = ((ExecutionInfoSummary)o2).bytes - ((ExecutionInfoSummary)o1).bytes;
               break;
           case RELEASED_BYTES:
               compare = ((ExecutionInfoSummary)o2).releasedBytes- ((ExecutionInfoSummary)o1).releasedBytes;
               break;
           case NUMBER_OF_CALLINGS:
               compare = ((ExecutionInfoSummary)o2).numberOfCallings- ((ExecutionInfoSummary)o1).numberOfCallings;
               break;
        }
        if (compare>0) compret=1;
        else if (compare<0) compret=-1;
        else {
            compret = ((ExecutionInfoSummary)o1).getFullName().compareTo(((ExecutionInfoSummary)o2).getFullName());
        }
        
        
        return compret;
    }

}
