/*
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.profiler.liteversion.consolidator;

import java.io.*;
import java.net.*;

/**
 * Talks to {@link DataSynchronizer} over socket.
 * @author Clebert Suconic
 */
public class DataConsumer {

    String host;
    int port;
    /**
     * 
     */
    public DataConsumer(String host,int port) {
        super();
        this.host=host;
        this.port=port;
    }
    
    public Object[] getMessages() throws IOException, ClassNotFoundException {
        Socket socket = new Socket(host,port);
        ObjectInputStream inp = new ObjectInputStream(socket.getInputStream());
        ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
        
        out.writeObject("DATACONSUMER");
        out.flush();
        out.reset();
        
        Object messages = inp.readObject();
        
        inp.close();
        out.close();
        socket.close();
        return (Object[])messages;
    }

    public void saveMessage() throws IOException {
        sendCommand("SAVEDATA");
    }

    public void deActivateMessage() throws IOException {
        sendCommand("DEACTIVATE");
    }

    public void activateMessage() throws IOException {
        sendCommand("ACTIVATE");
    }

    /**
     * @throws UnknownHostException
     * @throws IOException
     */
    private void sendCommand(String command) throws UnknownHostException, IOException {
        Socket socket = new Socket(host,port);
        ObjectInputStream inp = new ObjectInputStream(socket.getInputStream());
        ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
        
        out.writeObject(command);
        out.flush();
        out.reset();
        
        inp.close();
        out.close();
        socket.close();
    }

}
