/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.aop.test;

import java.io.IOException;

import org.jboss.profiler.aop.profiler.control.ProfilerController;

/**
 * @author Clebert Suconic
 */
public class TestPojo {

    public static void main(String arg[]) {
        try {
            ProfilerController.getInstance().setStarted(true);
        } catch (IOException e) {
            e.printStackTrace();
        }
        new TestPojo().driver();
    }

    public void driver() {
        for (int i = 0; i < 10; i++) {
            test1();
        }
    }

    private void test1() {
        System.out.println("test1 - private");
        test2();
    }

    private void test2() {
        test3();
    }

    private void test3() {
        TestPojoInstance pojo = new TestPojoInstance("test");
        pojo.doTest();
    }

}