/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.console;

import java.net.ServerSocket;
import java.net.Socket;
import java.util.HashMap;


/** This class executes the wake-up signal on the profiler over socket.
 *  It controls the life cycle of the profiler.
@author Clebert Suconic
*/
public class ProfilerControl implements java.lang.Runnable {

   public synchronized void addControl(Long pid, ProfilerPID spyPid) {
      hash.put(pid,spyPid);
   }

   public synchronized void removeControl(Long pid) {
      hash.remove(pid);
   }

   HashMap hash = new HashMap();

   ProfilerConsole console = null;
   int port;
   public ProfilerControl (ProfilerConsole console,int port) {
      this.console=console;
      this.port=port;
   }

   public void run() {
     try {
      ServerSocket socketServer = new ServerSocket(port);
      while (true) {
        Socket socket = socketServer.accept();
        ProfilerPID spyPid = new ProfilerPID(socket,this);
        addControl (new Long(spyPid.getPid()),spyPid);
        console.printMenu();
      }
     }
     catch (Exception e) {
       e.printStackTrace();
     }
   }
  public ProfilerConsole getConsole() {
    return console;
  }
  public HashMap getHash() {
    return hash;
  }
}