/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.fileProcessor;

import java.io.DataInput;
import java.io.IOException;


/**
@author Clebert Suconic
*/
public class SpyRegisterLoadMethod extends SpyRegister {
    /**
     * Read a ThreadStart register. The ID, clock and time_t is present on identRegister, and isn`t necessary to read these attributes.
     */
    public void read(DataInput dataInput, SpyRegister identRegister) throws IOException {
        this.setValues(identRegister);
        classId = dataInput.readInt();
        methodId = dataInput.readInt();
        methodName = InputUtil.readString(dataInput);
        signature =InputUtil.readString(dataInput);
    }

    public int getClassId(){
            return classId;
        }

    public void setClassId(int classId){
            this.classId = classId;
        }

    public int getMethodId(){
            return methodId;
        }

    public void setMethodId(int methodId){
            this.methodId = methodId;
        }

    public String getMethodName(){ return methodName; }

    public void setMethodName(String methodName){ this.methodName = methodName; }

    public String getSignature(){ return signature; }

    public void setSignature(String signature){ this.signature = signature; }

    public String toString() {
        return super.toString() + " classId = " + classId + " methodId = " + methodId + " methodName = " + methodName + " signature = " + signature;
    }

    private int classId;
    private int methodId;
    private String methodName;
    private String signature;
}
