/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.fileProcessor;

import java.io.DataInput;
import java.io.IOException;

/**
@author Clebert Suconic
*/
public class SpyRegisterLoadObject extends SpyRegister {
    /**
     * Read a ThreadStart register. The ID, clock and time_t is present on identRegister, and isn`t necessary to read these attributes.
     */
    public void read(DataInput dataInput, SpyRegister identRegister) throws IOException {
        this.setValues(identRegister);
        envId = dataInput.readInt();
        threadId = dataInput.readInt();
        classId = dataInput.readInt();
        objectId = dataInput.readInt();
        size = dataInput.readInt();
    }

    public int getEnvId(){
            return envId;
        }

    public void setEnvId(int envId){
            this.envId = envId;
        }

    public int getClassId(){
            return classId;
        }

    public void setClassId(int classId){
            this.classId = classId;
        }

    public int getObjectId(){
            return objectId;
        }

    public void setObjectId(int objectId){
            this.objectId = objectId;
        }

    public String toString() {
        return super.toString() +" envId = " + envId +" classId = " + classId + " objectId = " + objectId;
    }

    public int getThreadId(){
            return threadId;
        }

    public void setThreadId(int threadId){
            this.threadId = threadId;
        }
  public int getSize() {
    return size;
  }
  public void setSize(int size) {
    this.size = size;
  }

    private int envId;
    private int classId;
    private int objectId;
    private int threadId;
    private int size;
}
