/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.graphmodel;

import java.io.Serializable;

/**
 * GraphCallings is the central Object of graphapplet.
 * A servlet will produce this object, sending to the applet the
 * right objects needed to be included into the graphView.
@author Clebert Suconic
*/
public class GraphCallings implements Serializable {

  private static final long serialVersionUID = 100L;

  /** list of {@link GraphMethod}*/
  private java.util.ArrayList methods;

  /** list of {@link GraphReference}*/
  private java.util.ArrayList references;

  public java.util.ArrayList getMethods() {
    return methods;
  }
  public void setMethods(java.util.ArrayList methods) {
    this.methods = methods;
  }
  public void setReferences(java.util.ArrayList references) {
    this.references = references;
  }
  public java.util.ArrayList getReferences() {
    return references;
  }

  public void printDebug() {
  	System.out.println("Methods:");
  	java.util.Iterator iter = methods.iterator();
  	while (iter.hasNext()){
  		GraphMethod graphMethod = (GraphMethod)iter.next();
  		System.out.println("id=" + graphMethod.getMethodId() + " name=" + graphMethod.getName() + " level = " + graphMethod.getLevel());
  	}

	System.out.println("References:");
	iter = references.iterator();
	while (iter.hasNext()){
		GraphReference graphReference = (GraphReference)iter.next();
		System.out.println("id callee="+graphReference.getMethodCallee() + " level callee="+graphReference.getLevelCallee() +
		                    " id called="+graphReference.getMethodCalled() + " level called="+graphReference.getLevelCalled());
	}
  }




}
