/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.memoryprofiler.model;

import java.util.HashMap;

/**
 * Summarizes the references between objects
 *
 * @author Clebert Suconic
 */
public class MemoryReferenceSummary {
    int numberOfReferences;

    int numberOfDistinctObjects;

    int numberOfThreadReferences;

    MemoryClass referenceTo;

    HashMap objectsReferenced = new HashMap();

    /**
     * @return Returns the objectsReferenced.
     */
    public HashMap getObjectsReferenced() {
        return objectsReferenced;
    }
    /**
     * @return Returns the numberOfThreadReferences.
     */
    public int getNumberOfThreadReferences() {
        return numberOfThreadReferences;
    }
    /**
     * @param numberOfThreadReferences The numberOfThreadReferences to set.
     */
    public void setNumberOfThreadReferences(int numberOfThreadReferences) {
        this.numberOfThreadReferences = numberOfThreadReferences;
    }

    /**
     * @return Returns the numberOfDistinctObjects.
     */
    public int getNumberOfDistinctObjects() {
        return numberOfDistinctObjects;
    }

    /**
     * @param numberOfDistinctObjects
     *            The numberOfDistinctObjects to set.
     */
    public void setNumberOfDistinctObjects(int numberOfDistinctObjects) {
        this.numberOfDistinctObjects = numberOfDistinctObjects;
    }

    /**
     * @return Returns the numberOfReferences.
     */
    public int getNumberOfReferences() {
        return numberOfReferences;
    }

    /**
     * @param numberOfReferences
     *            The numberOfReferences to set.
     */
    public void setNumberOfReferences(int numberOfReferences) {
        this.numberOfReferences = numberOfReferences;
    }

    /**
     * @return Returns the referenceTo.
     */
    public MemoryClass getReferenceTo() {
        return referenceTo;
    }
    /**
     * @param referenceTo The referenceTo to set.
     */
    public void setReferenceTo(MemoryClass referenceTo) {
        this.referenceTo = referenceTo;
    }
}