package org.jboss.profiler.memoryprofiler.model;

import java.util.ArrayList;

/** Aggregates references to aggregating it by Object */
public class ReferenceContainer {
    MemoryObject ref;

    /** A list of MemoryObjects that are taking reference to an object.
     *  It can contain MemoryObject or MemoryReferenceSummary depending on the useCase.
     *  On the model contains MemoryObject but during navigations contains MemoryRefernceSummary */
    ArrayList listOfReferences = new ArrayList();

    public ReferenceContainer(MemoryObject ref) {
        this.ref = ref;
    }

    /**
     * @return Returns the listOfReferences.
     */
    public ArrayList getListOfReferences() {
        return listOfReferences;
    }
    
    /**
     * @param listOfReferences The listOfReferences to set.
     */
    public void setListOfReferences(ArrayList listOfReferences)
    {
        this.listOfReferences = listOfReferences;
    }

    /**
     * @return Returns the ref.
     */
    public MemoryObject getRef() {
        return ref;
    }

    /**
     * The ref to set.
     * @param ref
     */
    public void setRef(MemoryObject ref) {
        this.ref = ref;
    }
    
    public int hashCode()
    {
        return ref.hashCode();
    }
    
    public boolean equals(Object obj)
    {
        return this.ref.equals(((ReferenceContainer)obj).ref);
    }
}