/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.model;

import java.util.HashMap;

/**
 * Extends {@link JBPMemoryCount} for having new specific properties on MemoryClass and objects counts.
@author Clebert Suconic
*/
public class JBPMemoryClassCount extends JBPMemoryCount {

  private static final long serialVersionUID = 100L;

    /** @associates <{JBPMemoryCount}>*/
    private HashMap threadCount = new HashMap();

    public JBPMemoryClassCount(Object referencedObject) {
        super(referencedObject);
    }

    public JBPMemoryClassCount(Object referencedObject, int count, int size) {
        super(referencedObject,count, size);
    }

    /** A clone is used during GCs reading. When instances of this classes will be copied for the new upcoming GC.*/
    public Object clone() {
        JBPMemoryClassCount newCount = new JBPMemoryClassCount(referencedObject,count - countRelease, size - releasedSize);
        newCount.threadCount = this.threadCount;
        return newCount;
    }
  public HashMap getThreadCount() {
    return threadCount;
  }

}
