/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.model;

import java.io.Serializable;
import java.util.Date;
import java.util.HashMap;

import org.jboss.profiler.util.JBPHashUtil;

/**
* The state of the MemorySpace during an instant T associated with a GC operation.
@author Clebert Suconic
*/
public class JBPMemoryState implements Serializable, Cloneable {

  private static final long serialVersionUID = 100L;

    private Date startGarbage;
    private Date endGarbage;

    /**
     *A chave da HashMap eh um JBPClass
     *@link aggregation
     *      @associates <{JBPMemoryClassCount}>
     */
    private HashMap inUse = new HashMap();
    private long cpuEndGarbage;
    private long cpuStartGarbage;

    public Date getStartGarbage(){ return startGarbage; }

    public void setStartGarbage(Date startGarbage){ this.startGarbage = startGarbage; }

    public Date getEndGarbage(){ return endGarbage; }

    public void setEndGarbage(Date endGarbage){ this.endGarbage = endGarbage; }

    public long getCpuStartGarbage(){
            return cpuStartGarbage;
        }

    public void setCpuStartGarbage(long cpuStartGarbage){
            this.cpuStartGarbage = cpuStartGarbage;
        }

    public long getCpuEndGarbage(){
            return cpuEndGarbage;
        }

    public void setCpuEndGarbage(long cpuEndGarbage){
            this.cpuEndGarbage = cpuEndGarbage;
        }

    public HashMap getInUse(){
            return inUse;
        }

    public Object clone() {
        JBPMemoryState memState = new JBPMemoryState();
        memState.startGarbage=this.startGarbage;
        memState.endGarbage=this.endGarbage;
        memState.cpuStartGarbage=cpuStartGarbage;
        memState.cpuEndGarbage=cpuEndGarbage;

        memState.inUse = JBPHashUtil.cloneHash(inUse);

        return memState;
    }
}
