/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.model;

import java.io.Serializable;

/** Relationship between {@link JBPMethod} e {@link SPYThread}
@author Clebert Suconic
*/
public class JBPMethodThread implements Serializable {

  private static final long serialVersionUID = 100L;

  private JBPThread spyThread;
  private JBPMethod spyMethod;
  private JBPMethod spyMethodOnThread;

  private JBPMethodThread () {
  }

  public JBPMethodThread (JBPThread spyThread, JBPMethod spyMethod,JBPMethod spyMethodOnThread) {
     this.spyThread=spyThread;
     this.spyMethod=spyMethod;
     this.spyMethodOnThread=spyMethodOnThread;
  }

  public org.jboss.profiler.model.JBPThread getSpyThread() {
    return spyThread;
  }

  public void setSpyThread(org.jboss.profiler.model.JBPThread spyThread) {
    this.spyThread = spyThread;
  }

  public void setSpyMethod(org.jboss.profiler.model.JBPMethod spyMethod) {
    this.spyMethod = spyMethod;
  }

  public org.jboss.profiler.model.JBPMethod getSpyMethod() {
    return spyMethod;
  }

  public void setSpyMethodOnThread(org.jboss.profiler.model.JBPMethod spyMethodOnThread) {
    this.spyMethodOnThread = spyMethodOnThread;
  }

  public org.jboss.profiler.model.JBPMethod getSpyMethodOnThread() {
    return spyMethodOnThread;
  }

}
