/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.profiler.tracerModel;

import java.io.Serializable;

/**
 * @author Yoko Seki (y-seki@sdl.hitachi.com)
 */
public class JBTSearchCondition implements Serializable
{
   private int tranStartY1;    //YEAR
   private int tranStartM1;    //MONTH
   private int tranStartD1;    //DATE
   private int tranStartHH1;   //HOUR
   private int tranStartMM1;   //MINUTE
   private int tranStartSS1;   //SECOND
   private int tranStartMS1;   //MILLISECOND

   private int tranStartY2;    //YEAR
   private int tranStartM2;    //MONTH
   private int tranStartD2;    //DATE
   private int tranStartHH2;   //HOUR
   private int tranStartMM2;   //MINUTE
   private int tranStartSS2;   //SECOND
   private int tranStartMS2;   //MILLISECOND

   private int tranFinishY1;   //YEAR
   private int tranFinishM1;   //MONTH
   private int tranFinishD1;   //DATE
   private int tranFinishHH1;  //HOUR
   private int tranFinishMM1;  //MINUTE
   private int tranFinishSS1;  //SECOND
   private int tranFinishMS1;  //MILLISECOND

   private int tranFinishY2;   //YEAR
   private int tranFinishM2;   //MONTH
   private int tranFinishD2;   //DATE
   private int tranFinishHH2;  //HOUR
   private int tranFinishMM2;  //MINUTE
   private int tranFinishSS2;  //SECOND
   private int tranFinishMS2;  //MILLISECOND

   private String includeMethodName;   //names separeted by space " "
   private String excludeMethodName;   //names separated by space " "

   private int transactionTime;   //MILLISECOND

   private int methodTime;       //MILLISECOND

   public int getTranStartY1() { return tranStartY1; }
   public void setTranStartY1(int tranStartY1)
   { this.tranStartY1 = tranStartY1; }

   public int getTranStartM1() { return tranStartM1; }
   public void setTranStartM1(int tranStartM1)
   { this.tranStartM1 = tranStartM1; }

   public int getTranStartD1() { return tranStartD1; }
   public void setTranStartD1(int tranStartD1)
   { this.tranStartD1 = tranStartD1; }

   public int getTranStartHH1() { return tranStartHH1; }
   public void setTranStartHH1(int tranStartHH1)
   { this.tranStartHH1 = tranStartHH1; }

   public int getTranStartMM1() { return tranStartMM1; }
   public void setTranStartMM1(int tranStartMM1)
   { this.tranStartMM1 = tranStartMM1; }

   public int getTranStartSS1() { return tranStartSS1; }
   public void setTranStartSS1(int tranStartSS1)
   { this.tranStartSS1 = tranStartSS1; }

   public int getTranStartMS1() { return tranStartMS1; }
   public void setTranStartMS1(int tramStartMS1)
   { this.tranStartMS1 = tranStartMS1; }

   public int getTranStartY2() { return tranStartY2; }
   public void setTranStartY2(int tranStartY2)
   { this.tranStartY2 = tranStartY2; }

   public int getTranStartM2() { return tranStartM2; }
   public void setTranStartM2(int tranStartM2)
   { this.tranStartM2 = tranStartM2; }

   public int getTranStartD2() { return tranStartD2; }
   public void setTranStartD2(int tranStartD2)
   { this.tranStartD2 = tranStartD2; }

   public int getTranStartHH2() { return tranStartHH2; }
   public void setTranStartHH2(int tranStartHH2)
   { this.tranStartHH2 = tranStartHH2; }

   public int getTranStartMM2() { return tranStartMM2; }
   public void setTranStartMM2(int tranStartMM2)
   { this.tranStartMM2 = tranStartMM2; }

   public int getTranStartSS2() { return tranStartSS2; }
   public void setTranStartSS2(int tranStartSS2)
   { this.tranStartSS2 = tranStartSS2; }

   public int getTranStartMS2() { return tranStartMS2; }
   public void setTranStartMS2(int tranStartMS2)
   { this.tranStartMS2 = tranStartMS2; }

   public int getTranFinishY1() { return tranFinishY1; }
   public void setTranFinishY1(int tranFinishY1)
   { this.tranFinishY1 = tranFinishY1; }

   public int getTranFinishM1() { return tranFinishM1; }
   public void setTranFinishM1(int tranFinishM1)
   { this.tranFinishM1 = tranFinishM1; }

   public int getTranFinishD1() { return tranFinishD1; }
   public void setTranFinishD1(int tranFinishD1)
   { this.tranFinishD1 = tranFinishD1; }

   public int getTranFinishHH1() { return tranFinishHH1; }
   public void setTranFinishHH1(int tranFinishHH1)
   { this.tranFinishHH1 = tranFinishHH1; }

   public int getTranFinishMM1() { return tranFinishMM1; }
   public void setTranFinishMM1(int tranFinishMM1)
   { this.tranFinishMM1 = tranFinishMM1; }

   public int getTranFinishSS1() { return tranFinishSS1; }
   public void setTranFinishSS1(int tranFinishSS1)
   { this.tranFinishSS1 = tranFinishSS1; }

   public int getTranFinishMS1() { return tranFinishMS1; }
   public void setTranFinishMS1(int tramFinishMS1)
   { this.tranFinishMS1 = tranFinishMS1; }

   public int getTranFinishY2() { return tranFinishY2; }
   public void setTranFinishY2(int tranFinishY2)
   { this.tranFinishY2 = tranFinishY2; }

   public int getTranFinishM2() { return tranFinishM2; }
   public void setTranFinishM2(int tranFinishM2)
   { this.tranFinishM2 = tranFinishM2; }

   public int getTranFinishD2() { return tranFinishD2; }
   public void setTranFinishD2(int tranFinishD2)
   { this.tranFinishD2 = tranFinishD2; }

   public int getTranFinishHH2() { return tranFinishHH2; }
   public void setTranFinishHH2(int tranFinishHH2)
   { this.tranFinishHH2 = tranFinishHH2; }

   public int getTranFinishMM2() { return tranFinishMM2; }
   public void setTranFinishMM2(int tranFinishMM2)
   { this.tranFinishMM2 = tranFinishMM2; }

   public int getTranFinishSS2() { return tranFinishSS2; }
   public void setTranFinishSS2(int tranFinishSS2)
   { this.tranFinishSS2 = tranFinishSS2; }

   public int getTranFinishMS2() { return tranFinishMS2; }
   public void setTranFinishMS2(int tranFinishMS2)
   { this.tranFinishMS2 = tranFinishMS2; }

   public String getIncludeMethodName() { return includeMethodName; }
   public void setIncludeMethodName(String includeMethodName)
   { this.includeMethodName = includeMethodName; }

   public String getExcludeMethodName() { return excludeMethodName; }
   public void setExcludeMethodName(String excludeMethodName)
   { this.excludeMethodName = excludeMethodName; }

   public int getTransactionTime() { return transactionTime; }
   public void setTransactionTime(int transactionTime)
   { this.transactionTime = transactionTime; }

   public int getMethodTime() { return methodTime; }
   public void setMethodTime(int methodTime)
   { this.methodTime = methodTime; }

}
