/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.profiler.tracerModel;

import java.util.*;
import java.io.Serializable;

/**
 * @author Yoko Seki (y-seki@sdl.hitachi.co.jp)
 */
public class JBTTransaction implements Serializable
{
   private ArrayList methods;
   private int transactionID;
   private int currentMethod;
   private int currentDepth=0;
   private int numberOfLocks=0;
   private long lockTime=0;

   public ArrayList getMethods () { return methods; }
   public void setMethods (ArrayList methods) { this.methods = methods; }

   public int getTransactionID() { return transactionID; }
   public void setTransactionID (int transactionID) { this.transactionID = transactionID;}

   public int getCurrentMethod () { return currentMethod; }
   public void setCurrentMethod (int currentMethod) { this.currentMethod = currentMethod; }

   public int getCurrentDepth () { return currentDepth; }
   public void setCurrentDepth (int currentDepth) { this.currentDepth = currentDepth; }

    public int getNumberOfLocks()
    {
        return numberOfLocks;
    }

    public void setNumberOfLocks(int numberOfLocks)
    {
        this.numberOfLocks = numberOfLocks;
    }

    public long getLockTime()
    {
        return lockTime;
    }

    public void setLockTime(long lockTime)
    {
        this.lockTime = lockTime;
    }
}
