/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.util;

/**
 *
 * <p> Does Convertions between JNI notation and "Human" Notation</p>
 * Converts the parameters notations used on JNI interface to a real Java Notation.
@author Clebert Suconic
*/
public class SPYConvertUtil {

   public static String convertParameterList(String jniNotation) {
      StringBuffer bufferNotation = new StringBuffer();
      convertParameterList(jniNotation,bufferNotation);
      return bufferNotation.toString();

   }

   public static void convertParameterList(String jniNotation,StringBuffer bufferNotation) {
      char [] chars = new char[jniNotation.length()];
      jniNotation.getChars(0,jniNotation.length(),chars,0);

      // quantity of opened [
      int arrayOpened=0;
      for (int i=0;i<chars.length;i++) {
         if (chars[i]=='[') {
            arrayOpened++;
         } else
         if (chars[i]=='(') {
           bufferNotation.append(chars[i]);
         } else if (chars[i]==')') {
           bufferNotation.append("):");
         } else {
           if (chars[i]=='L') {
             for (i++;i<chars.length && chars[i]!=';';i++) {
                bufferNotation.append(chars[i]=='/'?'.':chars[i]);
             }
           } else {
             switch (chars[i]) {
                case 'Z': bufferNotation.append("boolean"); break;
                case 'B': bufferNotation.append("byte"); break;
                case 'C': bufferNotation.append("char"); break;
                case 'S': bufferNotation.append("short"); break;
                case 'I': bufferNotation.append("int"); break;
                case 'J': bufferNotation.append("long"); break;
                case 'F': bufferNotation.append("float"); break;
                case 'D': bufferNotation.append("double"); break;
                case 'V': bufferNotation.append("void"); break;
                default: bufferNotation.append("unknow(" + chars[i] + ")"); break;
             }
           }
           for (;arrayOpened>0;arrayOpened--) {
              bufferNotation.append("[]");
           }
           if (i+1<chars.length && chars[i+1]!=')') bufferNotation.append(',');
          }
      }
   }


}