/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.util;

import java.util.Comparator;
import org.jboss.profiler.model.*;

/**
@author Clebert Suconic
*/
public class SPYMethodCountComparator implements Comparator {
  public int compare(Object o1, Object o2) {
     JBPMethodCount s1 = (JBPMethodCount)o1;
     JBPMethodCount s2 = (JBPMethodCount)o2;

     long tmpRet = s2.getTotalClocks() - s1.getTotalClocks();
     if (tmpRet>0) return 1;
     else if (tmpRet<0) return -1;
     else {
        return s1.getSpyMethod().getName().compareTo(s2.getSpyMethod().getName());
     }
  }
}