/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/

package org.jboss.profiler.util;

import java.util.*;
import org.jboss.profiler.tracerModel.*;

/**
 * @author Yoko Seki (y-seki@sdl.hitachi.co.jp)
 */
public class SPYTransactionComparator implements Comparator {
  public static String sort;

  String order;
  public SPYTransactionComparator(String order) {
     this.order=order;
  }

  public int compare(Object o1, Object o2) {
                     JBTTransaction s1 = (JBTTransaction)o1;
                     JBTTransaction s2 = (JBTTransaction)o2;
                     int ret = 0;

                     ArrayList methods1 = s1.getMethods();
                     ArrayList methods2 = s2.getMethods();

                     if (order.equals("lockTime"))
                     {
                         ret =(int)(s2.getLockTime() - s1.getLockTime());
                     }
                     if (order.equals("numberOfLocks"))
                     {
                         ret = s2.getNumberOfLocks() - s1.getNumberOfLocks();
                     }
                     if (order.equals("methodsNum")) {
                         ret = methods2.size() - methods1.size();
                     }
                     else if (order.equals("cpu"))
                     {
                        long s1StartCpu = ((JBTMethod)methods1.get(0)).getClockStart();
                        long s1EndCpu   = ((JBTMethod)methods1.get(0)).getClockEnd();

                        long s2StartCpu = ((JBTMethod)methods2.get(0)).getClockStart();
                        long s2EndCpu   = ((JBTMethod)methods2.get(0)).getClockEnd();

                        ret = (int) ((s2EndCpu-s2StartCpu) - (s1EndCpu-s1StartCpu));
                     }

                     else
                     {
                        long s1StartTime = ((JBTMethod)methods1.get(0)).getElapsedClockStart();
                        long s1EndTime   = ((JBTMethod)methods1.get(0)).getElapsedClockEnd();

                        long s2StartTime = ((JBTMethod)methods2.get(0)).getElapsedClockStart();
                        long s2EndTime   = ((JBTMethod)methods2.get(0)).getElapsedClockEnd();

                        if (order.equals("startTime")) ret = (int) (s2StartTime - s1StartTime);
                        else if (order.equals("endTime")) ret = (int) (s2EndTime - s1EndTime);
                        else if (order.equals("totalTime"))
                           ret = (int) ((s2EndTime-s2StartTime) - (s1EndTime-s1StartTime));
                     }

                     if (sort.equals("up")) ret = -ret;

                     if (ret!=0) {
                        if (ret>0) return 1;
                        else if (ret<0) return -1;
                        else return 0;
                     }
                     else  {
                         return -1;
                     }
  }
}
