/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler;

import org.jboss.aop.pointcut.ast.ParseException;

/**
 * This MBean can appoint to an existent Monitoring class.
 * It shows the root-statistics and the current-grade statistics.
 * @author Clebert Suconic
 */
public interface AOPStatisticsMonitoringServiceMBean {
    /** Returns all available measures to be used on this statistic*/
    public String[] getAvailableMeasures();

    /** Pointcut to be invoked after started */
    public void setPointcut(String pointcut) throws ParseException;
    /** Pointcut to be invoked after started */
    public String getPointcut();

    /** Will call the addPointcut */
    public void start() throws ParseException;

    public void setCurrentMeasure(String measure);
    public String getCurrentMeasure();

    public long getCallings();

    public long getAvgTime();

    public long getMaxThreads();

    public long getCurrentGradeCallings();

    public long getCurrentGradeMaxThreads();

    public long getCurrentGradeAvgTime();

    public boolean isStarted();
}
