/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler;

import org.jboss.profiler.threadcheck.StartupProfilerCheck;



/**
 * @author Clebert Suconic
 */
public class NativeProfilerService implements NativeProfilerServiceMBean {

    /* (non-Javadoc)
     * @see org.jboss.profiler.NativeProfilerMbean#pause()
     */
    public void pause() {
        StartupProfilerCheck.pauseProfiler();
    }

    /* (non-Javadoc)
     * @see org.jboss.profiler.NativeProfilerMbean#start()
     */
    public void activate() {
        StartupProfilerCheck.startProfiler();
    }

    /* (non-Javadoc)
     * @see org.jboss.profiler.NativeProfilerMbean#stop()
     */
    public void stop() {
        StartupProfilerCheck.stopProfiler();
    }


    public void activeTimeout(long timeout)
    {
        activate();

        try {
            Thread.sleep(timeout);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }


        stop();
    }

}
