/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.antprofiler;

import junit.framework.TestCase;

import org.jboss.ant.taskdefs.JUnitLiteProfilerListener;
import org.jboss.profiler.liteversion.consolidator.ConsolidatorData;
import org.jboss.profiler.liteversion.consolidator.DataProducerProxy;
import org.jboss.profiler.liteversion.consolidator.DataSynchronizer;

/**
 * @author Clebert Suconic
 */
public class DataSynchronizerTest extends TestCase {

    public DataSynchronizerTest() {
        super();
    }

    public DataSynchronizerTest(String arg0) {
        super(arg0);
    }

    public void testRunning() throws Exception {
        DataSynchronizer.startSynchronizer(1000);

        DataProducerProxy.startProducer("localhost:1000");
        DataProducerProxy.startProducer("localhost:1000");

        Thread.sleep(1000);
        for (int i=0;i<20;i++) {
            ConsolidatorData data = JUnitLiteProfilerListener.readData("localhost",1000);
            System.out.println("data["+i+"]=" + data);
        }

    }


}
