/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.antprofiler;

import java.util.ArrayList;

import org.jboss.profiler.liteversion.jni.LiteVersionController;

import junit.framework.TestCase;

/**
 * @author Clebert Suconic
 */
public class LiteVersionInterfaceTest extends TestCase {

    public void testBasicInterface() {
        ArrayList list = new ArrayList();
        for (int i=0;i<1000;i++) {
            list.add("Test                      " + i);
        }

        System.out.println("\nround 1");
        System.out.println("Bytes=" + LiteVersionController.getBytes());
        System.out.println("Objects Created=" + LiteVersionController.getCreatedObjects());
        System.out.println("Released Objects=" + LiteVersionController.getReleasedObjects());

        LiteVersionController.runGC();

        System.out.println("\nround 2");
        System.out.println("Bytes=" + LiteVersionController.getBytes());
        System.out.println("Objects Created=" + LiteVersionController.getCreatedObjects());
        System.out.println("Released Objects=" + LiteVersionController.getReleasedObjects());

        list.clear();

        System.out.println("\nround 3 (clean without GC)");
        System.out.println("Bytes=" + LiteVersionController.getBytes());
        System.out.println("Objects Created=" + LiteVersionController.getCreatedObjects());
        System.out.println("Released Objects=" + LiteVersionController.getReleasedObjects());

        LiteVersionController.runGC();

        System.out.println("\nround 4 (clean after GC)");
        System.out.println("Bytes=" + LiteVersionController.getBytes());
        System.out.println("Objects Created=" + LiteVersionController.getCreatedObjects());
        System.out.println("Released Objects=" + LiteVersionController.getReleasedObjects());


        LiteVersionController.saveCurrentInfo();

        System.out.println("\nround 5 (after saveCurrentInfo)");
        System.out.println("Bytes=" + LiteVersionController.getBytes());
        System.out.println("Objects Created=" + LiteVersionController.getCreatedObjects());
        System.out.println("Released Objects=" + LiteVersionController.getReleasedObjects());
    }

}
