/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.liteversion.output;

import org.jboss.profiler.liteversion.consolidator.ConsolidatorData;

import junit.framework.TestCase;

/**
 * @author Clebert Suconic
 */
public class ConsolidatorDataFactoryTest extends TestCase {
     /** Tests if a ConsolidatorData can be described into name pair values into StringTokenized string with ';' and parsed back.*/
     public void testDataDescribe() throws Exception{
         ConsolidatorData data = new ConsolidatorData();
         data.setAllocatedMemory(30);
         data.setName("test");
         data.setObjectsAllocated(-1);
         data.setObjectsReleased(-2);

         String line = ConsolidatorDataFactory.exportProperties(data);

         ConsolidatorData data2 = ConsolidatorDataFactory.importProperties(line);

         assertEquals(data.getName(),data2.getName());
         assertEquals(data.getAllocatedMemory(),data2.getAllocatedMemory());
         assertEquals(data.getObjectsAllocated(),data2.getObjectsAllocated());
         assertEquals(data.getObjectsReleased(),data2.getObjectsReleased());

         System.out.println(data2.getName());

     }
}
