/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.web.actions;

import java.io.File;
import java.io.FilenameFilter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.jboss.profiler.web.form.FilterForm;

/**
@author Clebert Suconic
*/
public class FilterAction extends Action {
      public ActionForward perform(ActionMapping mapping,
                               ActionForm form,
                               HttpServletRequest request,
                               HttpServletResponse response) {
                FilterForm filterForm = (FilterForm)form;

                try {

                      File file = new File(filterForm.getDirectory());
                      if (!file.exists()) {
                         filterForm.setMessage("Directory " + filterForm.getDirectory() + " not found");
                         return mapping.findForward("errorSelection");
                      }
                      if (!file.isDirectory()) {
                         filterForm.setMessage("File " + filterForm.getDirectory() + " is not a directory");
                         return mapping.findForward("errorSelection");
                      }

                      File[] files = file.listFiles(new SPYFilterMain());
                      String[] pids = new String[files.length];
                      for (int i=0;i<files.length;i++) {
                        String str = files[i].getName().substring(10);
                        str=str.substring(0,str.indexOf("_main"));
                        pids[i]=str;
                      }
                      filterForm.setPids(pids);
                      return mapping.findForward("selectPID");
                  }
                  catch (Exception e) {
                     e.printStackTrace();
                     filterForm.setMessage(e.getMessage());
                     return mapping.findForward("errorSelection");
                  }

      }

    class SPYFilterMain implements FilenameFilter {
        public SPYFilterMain() {
        }

        public boolean accept(File file, String name){
            return name.startsWith("serverspy_") && name.indexOf("_main")>0;
        }
    }

}