/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.web.servlets;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.zip.GZIPOutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
@author Clebert Suconic
*/
public class ServletDownlolad extends HttpServlet {
  private static final String CONTENT_TYPE = "application/x-gzip-compressed";
  //Initialize global variables
  public void init() throws ServletException {
  }
  //Process the HTTP Get request
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
     try {
       response.setContentType(CONTENT_TYPE);
       GZIPOutputStream zipOut = new GZIPOutputStream(response.getOutputStream());
       ObjectOutputStream outObj = new ObjectOutputStream(zipOut);
       Object sessionContent = request.getSession(false).getAttribute("filterForm");
       outObj.writeObject(sessionContent);
       outObj.flush();
       zipOut.flush();
       zipOut.finish();
      }
      catch (Exception e) {
       e.printStackTrace();
       throw new IOException (e.getMessage());
      }
  }

  //Clean up resources
  public void destroy() {
  }
}