/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.web.servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import org.apache.commons.fileupload.*;
import org.jboss.profiler.web.form.FilterForm;

/**
@author Clebert Suconic
*/
public class ServletUpload extends HttpServlet {

  private static String getTempDir() {
     return System.getProperty("java.io.tmpdir");
  }

  private static final String CONTENT_TYPE = "text/html";
  //Initialize global variables
  public void init() throws ServletException {
  }
  //Process the HTTP Put request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
     try {
       Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
       FileUpload upload = new FileUpload();
       //List files = upload.parseRequest(request,10*1024*1024,10*1024*1024,"c:\\temp");
       //System.g
       System.out.println("usando " + getTempDir());
       List files = upload.parseRequest(request,-1,-1,getTempDir());

       InputStream input = (InputStream)((FileItem)files.get(0)).getInputStream();
       GZIPInputStream ginput = new GZIPInputStream(input);
       ObjectInputStream objinput = new ObjectInputStream(ginput);
       Object obj = objinput.readObject();
       if (obj instanceof FilterForm) {
         FilterForm filter = (FilterForm)obj;
         request.getSession().setAttribute("filterForm",filter);
       } else if (obj instanceof org.jboss.profiler.model.JBPProcess) {
          org.jboss.profiler.model.JBPProcess process =
            (org.jboss.profiler.model.JBPProcess) obj;
          FilterForm filter = new FilterForm();
          filter.setDirectory("noDir");
          filter.setSelectedPID("unknow");
          filter.setMessage("noMessage");
          filter.setJbpProcess(process);
         request.getSession().setAttribute("filterForm",filter);

       }

       RequestDispatcher dispatcher = request.getRequestDispatcher("mainMenu.jsp");
       dispatcher.forward(request,response);
     }
     catch (FileUploadException e) {
        e.printStackTrace();
        throw new IOException (e.getMessage());
     }
     catch (ClassNotFoundException e) {
        e.printStackTrace();
        throw new IOException (e.getMessage());
     }
  }
  //Clean up resources
  public void destroy() {
  }
}