/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.profiler.web.servlets;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUpload;
import org.apache.commons.fileupload.FileUploadException;

/**
@author Clebert Suconic
*/
public class ServletUploadFile extends HttpServlet {

  private static String getTempDir() {
     return System.getProperty("java.io.tmpdir");
  }

  private static final String CONTENT_TYPE = "text/html";
  //Initialize global variables

  public void init() throws ServletException {
  }
  //Process the HTTP Put request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
     try {
       Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
       FileUpload upload = new FileUpload();
       List files = upload.parseRequest(request,-1,-1,getTempDir());

       String destDir = request.getParameter("target.dir");
       if (destDir==null) {
          destDir = getTempDir();
       }

       FileItem file = ((FileItem)files.get(0));

       File fileDesc = new File(file.getName());


       FileOutputStream fileOut = new FileOutputStream(new File(destDir,fileDesc.getName()));

       InputStream input = (InputStream)((FileItem)files.get(0)).getInputStream();
       byte[] buffer = new byte[1024];
       int sizeBuffer=0;
       while ((sizeBuffer=input.read(buffer))>0) {
          fileOut.write(buffer,0,sizeBuffer);
       }

       fileOut.close();
       input.close();
       file.delete();

       RequestDispatcher dispatcher = request.getRequestDispatcher("transferOK.jsp");
       dispatcher.forward(request,response);
     }
     catch (FileUploadException e) {
        e.printStackTrace();
        throw new IOException (e.getMessage());
     }
  }
  //Clean up resources
  public void destroy() {
  }
}