<%
    /*
     * Distributable under LGPL license.
     * See terms of license at gnu.org.

     * This file belongs to a simple implementation of a web interface for the "disconnectedProfiler".
    */
%>

<%@ include file="processMenu.inc" %>

<%
    try {
%>
<table class="TABELA" width="100%">
<%
    Integer methodId = new Integer(request.getParameter("methodId"));
    JBPMethod keyMethod = new JBPMethod();
    keyMethod.setMethodID(methodId.intValue());

    Integer threadId = null;
    JBPThread thread = null;

    if (request.getParameter("threadId") != null) {
        JBPThread threadKey = new JBPThread();
        threadId = new Integer(request.getParameter("threadId"));
        threadKey.setThreadId(threadId.intValue());
        thread = (JBPThread) jbpProcess.getSpyThreads().get(threadKey);
    }

    HashMap JBPMethods = jbpProcess.getSpyMethods();
    JBPMethod JBPMethodProcess = (JBPMethod) JBPMethods.get(keyMethod);

    JBPMethodCount consolidacao = (JBPMethodCount) request.getSession().getAttribute("consolidacaoMetodo");
    if (thread == null && (consolidacao == null || !consolidacao.getSpyMethod().equals(JBPMethodProcess) || session.getAttribute("consolidacaoThread") != null)) {
        consolidacao = jbpProcess.consolidaCallings(JBPMethodProcess);
        session.setAttribute("consolidacaoMetodo", consolidacao);
        session.removeAttribute("consolidacaoThread");
    } else {
        JBPThread consolidacaoThread = (JBPThread) session.getAttribute("consolidacaoThread");
        if (thread != null && (consolidacao == null || consolidacaoThread == null || consolidacaoThread.getThreadId() != threadId.intValue() || !consolidacao.getSpyMethod().equals(JBPMethodProcess))) {
            consolidacao = thread.consolidaCallings(JBPMethodProcess);
            session.setAttribute("consolidacaoMetodo", consolidacao);
            session.setAttribute("consolidacaoThread", thread);
        }
    }

    // qual instancia sera utilizada no calculo
    JBPMethod JBPMethodToCalc = JBPMethodProcess;
    if (thread != null) {
        JBPMethodToCalc = (JBPMethod) thread.getSpyMethods().get(JBPMethodToCalc);
    }


    int numberOfPaths = 0;
    if (request.getParameter("npath") != null) {
        numberOfPaths = Integer.parseInt(request.getParameter("npath"));
    }

    int methodsId[] = new int[numberOfPaths];
    JBPMethod metodosPesquisados[] = new JBPMethod[numberOfPaths];
    JBPMethodCount[] consolidacoesPesquisadas = new JBPMethodCount[numberOfPaths];

    String urlBasesrc = "methodId=" + methodId; // url para seguir o caminho
    if (thread != null) {
        urlBasesrc += "&threadId=" + threadId;
    }
    for (int i = 0; i < numberOfPaths; i++) {
        methodsId[i] = Integer.parseInt(request.getParameter("m" + i));
        urlBasesrc += "&m" + i + "=" + methodsId[i];
        keyMethod.setMethodID(methodsId[i]);
        metodosPesquisados[i] = (JBPMethod) jbpProcess.getSpyMethods().get(keyMethod);
    }
    String urlBase = "./methodStack.jsp?" + urlBasesrc + "&npath=" + (numberOfPaths + 1) + "&m" + numberOfPaths + "=";
    String urlBaseObjects = "./methodStackObjects.jsp?" + urlBasesrc + "&npath=" + (numberOfPaths);
    String urlBaseChart = "./methodStackChart.jsp?" + urlBasesrc + "&npath=" + (numberOfPaths);
    String urlCriticalPath = "./methodCriticalPath.jsp?" + urlBasesrc + "&npath=" + (numberOfPaths);

    for (int i = 0; i < numberOfPaths; i++) {
        consolidacoesPesquisadas[i] = consolidacao.getCalledCount(metodosPesquisados[i]);
        consolidacao = consolidacoesPesquisadas[i];
    }

    JBPMethod methodConsolidado = consolidacao.getSpyMethod();
    methodConsolidado = (JBPMethod) JBPMethods.get(methodConsolidado);

%>

<%
    if (thread != null) {
        out.println("<tr><td colspan=14>Thread&nbsp;" + thread.getName() + "</td></tr>");
    }
    out.println("<tr><td colspan=14><img src=\"./imgs/arrow.gif\">" +
            "<a href=\"./methodStack.jsp?" + urlBasesrc + "\">" +
            JBPMethodProcess.getSimplifiedName() + " = 100% calls=" + JBPMethodToCalc.getNumberOfCalls() + "</td>");

    for (int i = 0; i < numberOfPaths; i++) {
        String percentCPU = "";
        if (JBPMethodToCalc.getTotalClock() != 0) {
            percentCPU = numberFormat.format(((double) consolidacoesPesquisadas[i].getTotalClocks() / (double) JBPMethodToCalc.getTotalClock()) * (double) 100);
        }

        String percentTime = "";
        if (JBPMethodToCalc.getTotalElapsedClock() != 0) {
            percentTime = numberFormat.format(((double) consolidacoesPesquisadas[i].getTotalElapsedClock() / (double) JBPMethodToCalc.getTotalElapsedClock()) * (double) 100);
        }


        String urlTmp = "./methodStack.jsp?" + urlBasesrc + "&npath=" + (i + 1);
        // estabelece recuperacao da arvore
        for (int j = 0; j <= i; j++) {
            urlTmp += "&m" + j + "=" + metodosPesquisados[j].getMethodID();
        }
        out.print("<tr><td colspan=14>");
        for (int j = 0; j <= i; j++) {
            out.print("&nbsp;");
        }
        out.println("<img src=\"./imgs/arrow.gif\">" +
                "<a href=\"" + urlTmp + "\">" +
                metodosPesquisados[i].getSimplifiedName() + " %CPU=" + percentCPU + "&nbsp;%Time=" + percentTime + " calls=" + consolidacoesPesquisadas[i].getCount() + "</a></td></tr>");
    }

    String strTree = "";
    {
        StringBuffer tmp = new StringBuffer();
        for (int i = 0; i < numberOfPaths; i++) {
            tmp.append("&nbsp;");
        }
        strTree = tmp.toString();
    }
%>

<tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
    <td bgcolor=white bordercolor=white></td>
    <td nowrap="nowrap">Callings</td>
    <td nowrap="nowrap">Avg Callings</td>
    <td nowrap="nowrap">% CPU</td>
    <td nowrap="nowrap">% Time</td>
    <td nowrap="nowrap">Name</td>
    <td nowrap="nowrap">CPU</td>
    <td nowrap="nowrap">Avg CPU</td>
    <td nowrap="nowrap">Time</td>
    <td nowrap="nowrap">Avg Time</td>
    <td nowrap="nowrap">#Locks</td>
    <td nowrap="nowrap">TimeLock</td>
    <td colspan=5>&nbsp;</td>
</tr>


<%


    TreeSet setMethods = null;

    // para ordenar pelo maior tempo
    setMethods = new TreeSet(new Comparator() {
        public int compare(Object o1, Object o2) {
            JBPGenericCount s1 = (JBPGenericCount) o1;
            JBPGenericCount s2 = (JBPGenericCount) o2;
            long x = s2.getTotalClocks() - s1.getTotalClocks();
            if (x != 0) {
                if (x > 0) return 1;
                else
                    return -1;
            } else if (((JBPMethod) s1.getReferencedObject()).getName() != null &&
                    ((JBPMethod) s2.getReferencedObject()).getName() != null) {
                return ((JBPMethod) s1.getReferencedObject()).getName().compareTo(((JBPMethod) s2.getReferencedObject()).getName());
            } else {
                return ((JBPMethod) s1.getReferencedObject()).getMethodID() - ((JBPMethod) s2.getReferencedObject()).getMethodID();
            }
        }
    });

    setMethods.addAll(consolidacao.getCountCalleds().values());

    double totalClock = jbpProcess.getTotalClocks();

    Iterator methodsIterator = setMethods.iterator();
    int line = 0;
    while (methodsIterator.hasNext()) {
        JBPGenericCount genericCount = (JBPGenericCount) methodsIterator.next();
        JBPMethod method = (JBPMethod) genericCount.getReferencedObject();
        if ((line++) % 2 == 0) {
            out.println("<tr bgcolor=white>");
        } else {
            out.println("<tr bgcolor=\"#cccccc\">");
        }

        out.println("<td  bgcolor=white bordercolor=white>" + strTree + "</td>");
        out.println("<td>" + genericCount.getCount() + "</td>");
        if (JBPMethodToCalc.getNumberOfCalls() > 0) {
            out.println("<td>" + genericCount.getCount() / JBPMethodToCalc.getNumberOfCalls() + "</td>");
        } else {
            out.println("<td>&nbsp;</td>");
        }
        if (JBPMethodProcess.getTotalClock() != 0) {
            out.println("<td>" + numberFormat.format(((double) genericCount.getTotalClocks() / (double) JBPMethodToCalc.getTotalClock()) * (double) 100) + "</td>");
        } else {
            out.println("<td>&nbsp;</td>");
        }

        if (JBPMethodToCalc.getTotalElapsedClock() != 0) {
            out.println("<td>" + numberFormat.format(((double) genericCount.getTotalElapsedClock() / (double) JBPMethodToCalc.getTotalElapsedClock()) * (double) 100) + "</td>");
        } else {
            out.println("<td>&nbsp;</td>");
        }
        method = (JBPMethod) jbpProcess.getSpyMethods().get(method);

        out.println("<td><a href=\"" + urlBase + method.getMethodID() + "\">" + method.getFullName() + "</a></td>");


        out.println("<td>" + (genericCount.getTotalClocks()) + "</td>");
        if (genericCount.getCount() > 0) {
            out.println("<td>" + (genericCount.getTotalClocks() / genericCount.getCount()) + "</td>");
        } else {
            out.println("<td>&nbsp;</td>");
        }


        out.println("<td>" + (genericCount.getTotalElapsedClock()) + "</td>");
        if (genericCount.getCount() > 0) {
            out.println("<td>" + (genericCount.getTotalElapsedClock() / genericCount.getCount()) + "</td>");
        } else {
            out.println("<td>&nbsp;</td>");
        }

        out.println("<td>" + genericCount.getNumberOfWaits() + "</td>");
        out.println("<td>" + genericCount.getTimeWait() + "</td>");


        out.println("<td> <a href=\"" + urlBase + method.getMethodID() + "\"> <img src='./imgs/arrow.gif'> </a></td>");
        out.println("<td> <a href=\"./methodStackCaller.jsp?methodId=" + method.getMethodID() + "\"> Callers </a></td>");
        out.println("<td> <a href=\"./methodStack.jsp?methodId=" + method.getMethodID() + "\"> Stick </a></td>");
        out.println("<td><a href=\"./methodsThread.jsp?methodId=" + method.getMethodID() + "\">Threads </a></td>");
        out.println("<td><a href=\"./JBTTransaction?methodList=" + method.getMethodID() + "\">Tracing</a></td>");
        out.println("</tr>");
    }
%>
</table>
<br>
    <table align=center>
        <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">

            <td class="sunblue"><a style="color:white;" href="<%=urlCriticalPath%>"> Critical Path </a></td>
            <td class="sunblue"><a style="color:white;" href="<%=urlBaseChart%>"> Pie Chart </a></td>
            <td class="sunblue"><a style="color:white;" href="<%=urlBaseObjects%>"> Instances Created </a></td>
            <td class="sunblue"><a style="color:white;" href="<%=urlBaseObjects%>&subMethods=1"> Instances Created +
                subMethods</a></td>
        </tr>
    </table>

</body>
</html>
<%
    }
    catch (Exception e) {
        e.printStackTrace();
    }
%>