<%
/*********************************************************************************/
/* The develepment of this program is partly supported by IPA                    */
/* (Information-Technology Promotion Agency, Japan).                             */
/*********************************************************************************/

/*********************************************************************************/
/*  transactionMethods.jsp                                                       */
/*  Copyright: Copyright (C) Hitachi, Ltd. 2005                                  */
/*             Author : Yoko SEKI (y-seki@sdl.hitachi.co.jp)                     */
/*  ChangeLog: (Thu Oct 06, 2005) First version release                          */
/*                                                                               */
/*                                                                               */
/*  This library is free software; you can redistribute it and/or                */
/*  modify it under the terms of the GNU Lesser General Public                   */
/*  License as published by the Free Software Foundation; either                 */
/*  version 2.1 of the License, or (at your option) any later version.           */
/*                                                                               */
/*  This library is distributed in the hope that it will be useful,              */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            */
/*  Lesser General Public License for more details.                              */
/*                                                                               */
/*  You should have received a copy of the GNU Lesser General Public             */
/*  License along with this library; if not, write to the Free Software          */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*********************************************************************************/
%>

<%@ include file="tracerInternal.inc"%>

<table class="TABELA">
   <tr bgcolor="#003366" bordercolor="#666666" style="COLOR:white;">
      <td nowrap="nowrap">Methods Order</td>
      <td nowrap="nowrap">Start Time</td>
      <td nowrap="nowrap">End Time</td>
      <td nowrap="nowrap">Total Time</td>
       <td nowrap="nowrap">CPU Time</td>
       <td nowrap="nowrap">#Locks</td>
       <td nowrap="nowrap">Lock Time</td>
   </tr>

<%
 try {
      Integer transactionID = new Integer(request.getParameter("transactionID"));
      ArrayList tokenizedMethod = new ArrayList();

      if (request.getParameter("methodInclude")!=null)
      {
         StringTokenizer methodToken = new StringTokenizer(request.getParameter("methodInclude"), " ");

         while (methodToken.hasMoreTokens())
         {
           tokenizedMethod.add(methodToken.nextToken());
         }
      }

      JBTTransaction keyTransaction = new JBTTransaction();
      Iterator iter = searchedTransactions.values().iterator();
      while ( iter.hasNext() )
      {
         keyTransaction = (JBTTransaction) iter.next();
         if ( keyTransaction.getTransactionID()==transactionID.intValue() )
           break;
      }

      ArrayList transactionMethods = keyTransaction.getMethods();
      HashMap processMethods = jbpProcess.getSpyMethods();

      int line=0;
      for ( int i=0; i<transactionMethods.size(); i++ )
      {
         JBTMethod transactionMethod = (JBTMethod) transactionMethods.get(i);
         String methodName = "";

         Iterator iter2 = processMethods.values().iterator();
         while ( iter2.hasNext() )
         {
            JBPMethod processMethod = (JBPMethod) iter2.next();
            if ( processMethod.getMethodID()==transactionMethod.getMethodID() )
            {
               methodName = processMethod.getSimplifiedName();
               break;
            }
         }

         if (transactionMethod.getNumberOfLocks()!=0)
         {
             out.println("<tr bgcolor=red>");
         } else
         {
             if ((line++)%2==0) out.println("<tr bgcolor=white>");
             else out.println("<tr bgcolor=\"#cccccc\">");
         }

         out.print("<td>");
         for ( int k=1; k<3*transactionMethod.getDepth(); k++)
         {
            out.print("&nbsp;");
         }

         boolean methodColor = false;
         if (request.getParameter("methodInclude")!=null)
         {
            for (int k=0; k<tokenizedMethod.size(); k++)
            {
               if (methodName.indexOf((String)tokenizedMethod.get(k))>=0)
               {
                  methodColor = true;
                  break;
               }
            }
         }

         if (methodColor)
            out.print("<font color=&quot;#0000ff&quot;><b>" + methodName + "</b></font></td>");
         else out.print(methodName + "</td>");

         long startTime = transactionMethod.getElapsedClockStart();
         long endTime   = transactionMethod.getElapsedClockEnd();

         Date date1 = new Date (startTime);
         DateFormat df = new SimpleDateFormat ("MM/dd/yyyy HH:mm:ss.SSS");
         out.print("<td>" + df.format(date1) + "</td>");

         if (endTime!=-1)
         {
            Date date2 = new Date(endTime);
            out.print("<td>" + df.format(date2) + "</td>");

            if ( (request.getParameter("methodElapse")!=null) &&
                 ((long)(endTime-startTime)>Long.parseLong(request.getParameter("methodElapse"))) )
                 out.print("<td><font color=&quot;#0000ff&quot;><b>" +
                            (long)(endTime-startTime) + "</b></font></td>");
            else out.print("<td>" + (long)(endTime-startTime) + "</td>");
         }
         else
         {
            if ( (request.getParameter("methodElapse")!=null) )
               out.print("<td><font color=&quot;#0000ff&quot;><b>NOT EXIT</b></font></td>");
            else out.print("<td>NOT EXIT</td>");

            out.print("<td>UNKNOWN</td>");
         }

         long startCPU = transactionMethod.getClockStart();
         long endCPU   = transactionMethod.getClockEnd();

         if (endCPU!=-1) out.print("<td>" + (long)(endCPU-startCPU) + "</td>");
         else out.print("<td>UNKNOWN</td>");

         if (transactionMethod.getNumberOfLocks()==0)
         {
             out.print("<td>&nbsp;</td><td>&nbsp;</td>");
         }
         else
         {
             out.print("<td>" + transactionMethod.getNumberOfLocks() + "</td>");
             out.print("<td>" + transactionMethod.getLockTime() + "</td>");
         }

         out.println("</tr>");
      }
   }
   catch (Exception e) {
     e.printStackTrace();
   }
%>
</table>
